
try:
    from pymol import cmd
except ImportError:
    print("PyMOL Python lib is missing")
    # sys.exit(0)

def spl_extract(): # sp
 for name in cmd.get_names("all"):
    
    print(" \ Extracting mode for %s" % name)
    if 'hpCs-II_7W5A'.lower() in name.lower():
        cmd.extract("PRP8_hpCs-II_7W5A", "chain A and hpCs-II_7W5A")
        cmd.extract("BUD31_hpCs-II_7W5A", "chain N and hpCs-II_7W5A")
        cmd.extract("CWC15_hpCs-II_7W5A", "chain P and hpCs-II_7W5A")
        cmd.extract("CWC2_RBM22_hpCs-II_7W5A", "chain O and hpCs-II_7W5A")
        cmd.extract("CWC22_hpCs-II_7W5A", "chain V and hpCs-II_7W5A")
        cmd.extract("PRP46_hpCs-II_7W5A", "chain T and hpCs-II_7W5A")
        cmd.extract("SYF2_hpCs-II_7W5A", "chain M and hpCs-II_7W5A")
        cmd.extract("SYF1_hpCs-II_7W5A", "chain I and hpCs-II_7W5A")
        cmd.extract("U2_hpCs-II_7W5A", "chain H and hpCs-II_7W5A")
        cmd.extract("U5_hpCs-II_7W5A", "chain B and hpCs-II_7W5A")
        cmd.extract("U6_hpCs-II_7W5A", "chain F and hpCs-II_7W5A")
        cmd.extract("5EXON_hpCs-II_7W5A", "chain 4 and hpCs-II_7W5A")
        cmd.extract("Intron_hpCs-II_7W5A", "chain G and hpCs-II_7W5A")
        cmd.extract("SLU7_hpCs-II_7W5A", "chain 1 and hpCs-II_7W5A")
        cmd.extract("PRKRIP1_hpCs-II_7W5A", "chain 2 and hpCs-II_7W5A")
        cmd.extract("AQR_hpCs-II_7W5A", "chain Q and hpCs-II_7W5A")
        cmd.extract("SNRP116_hpCs-II_7W5A", "chain C and hpCs-II_7W5A")
        cmd.extract("PPIL1_hpCs-II_7W5A", "chain S and hpCs-II_7W5A")
        cmd.extract("SNRNP200_hpCs-II_7W5A", "chain D and hpCs-II_7W5A")
        cmd.extract("PPIE_hpCs-II_7W5A", "chain y and hpCs-II_7W5A")
        cmd.extract("SNRNP40_hpCs-II_7W5A", "chain E and hpCs-II_7W5A")
        cmd.extract("SNRPD3_hpCs-II_7W5A", "(chain a or chain h ) and hpCs-II_7W5A")
        cmd.extract("SNRPB_hpCs-II_7W5A", "(chain b or chain i ) and hpCs-II_7W5A")
        cmd.extract("EIF4A3_hpCs-II_7W5A", "chain u and hpCs-II_7W5A")
        cmd.extract("SNRPD1_hpCs-II_7W5A", "(chain c or chain j ) and hpCs-II_7W5A")
        cmd.extract("MAGOH_hpCs-II_7W5A", "chain v and hpCs-II_7W5A")
        cmd.extract("SNRPD2_hpCs-II_7W5A", "(chain d or chain k ) and hpCs-II_7W5A")
        cmd.extract("RBM8A_hpCs-II_7W5A", "chain w and hpCs-II_7W5A")
        cmd.extract("SNRPF_hpCs-II_7W5A", "(chain f or chain m ) and hpCs-II_7W5A")
        cmd.extract("CASC3_hpCs-II_7W5A", "chain x and hpCs-II_7W5A")
        cmd.extract("SNRPE_hpCs-II_7W5A", "(chain e or chain l ) and hpCs-II_7W5A")
        cmd.extract("SNRPG_hpCs-II_7W5A", "(chain g or chain n ) and hpCs-II_7W5A")
        cmd.extract("SNRPA1_hpCs-II_7W5A", "chain o and hpCs-II_7W5A")
        cmd.extract("SNRPB2_hpCs-II_7W5A", "chain p and hpCs-II_7W5A")
        cmd.extract("CRNKL1_hpCs-II_7W5A", "chain J and hpCs-II_7W5A")
        cmd.extract("CDC5L_hpCs-II_7W5A", "chain L and hpCs-II_7W5A")
        cmd.extract("PRPF19_hpCs-II_7W5A", "(chain q or chain r or chain s or chain t ) and hpCs-II_7W5A")
        cmd.extract("BCAS2_hpCs-II_7W5A", "chain K and hpCs-II_7W5A")
        cmd.extract("SKIP_hpCs-II_7W5A", "chain R and hpCs-II_7W5A")
        cmd.extract("SRRM2_hpCs-II_7W5A", "chain U and hpCs-II_7W5A")
        cmd.extract("CDC40_hpCs-II_7W5A", "chain W and hpCs-II_7W5A")
        cmd.extract("DHX8_hpCs-II_7W5A", "chain Y and hpCs-II_7W5A")
        cmd.extract("FAM32A_hpCs-II_7W5A", "chain z and hpCs-II_7W5A")
        cmd.extract("NKAP_hpCs-II_7W5A", "chain 3 and hpCs-II_7W5A")
        cmd.extract("Cactin_hpCs-II_7W5A", "chain Z and hpCs-II_7W5A")
        cmd.set_name("hpCs-II_7W5A", "unknown_other_hpCs-II_7W5A")
        cmd.group("hpCs-II_7W5A", "*_hpCs-II_7W5A")
        cmd.do("order *, yes")
    if 'hpCs-I_7W59'.lower() in name.lower():
        cmd.extract("PRP8_hpCs-I_7W59", "chain A and hpCs-I_7W59")
        cmd.extract("BUD31_hpCs-I_7W59", "chain N and hpCs-I_7W59")
        cmd.extract("CWC15_hpCs-I_7W59", "chain P and hpCs-I_7W59")
        cmd.extract("CWC2_RBM22_hpCs-I_7W59", "chain O and hpCs-I_7W59")
        cmd.extract("CWC22_hpCs-I_7W59", "chain V and hpCs-I_7W59")
        cmd.extract("PRP46_hpCs-I_7W59", "chain T and hpCs-I_7W59")
        cmd.extract("SYF2_hpCs-I_7W59", "chain M and hpCs-I_7W59")
        cmd.extract("SYF1_hpCs-I_7W59", "chain I and hpCs-I_7W59")
        cmd.extract("U2_hpCs-I_7W59", "chain H and hpCs-I_7W59")
        cmd.extract("U5_hpCs-I_7W59", "chain B and hpCs-I_7W59")
        cmd.extract("U6_hpCs-I_7W59", "chain F and hpCs-I_7W59")
        cmd.extract("5EXON_hpCs-I_7W59", "chain 4 and hpCs-I_7W59")
        cmd.extract("Intron_hpCs-I_7W59", "chain G and hpCs-I_7W59")
        cmd.extract("SLU7_hpCs-I_7W59", "chain 1 and hpCs-I_7W59")
        cmd.extract("PRKRIP1_hpCs-I_7W59", "chain 2 and hpCs-I_7W59")
        cmd.extract("AQR_hpCs-I_7W59", "chain Q and hpCs-I_7W59")
        cmd.extract("SNRP116_hpCs-I_7W59", "chain C and hpCs-I_7W59")
        cmd.extract("PPIL1_hpCs-I_7W59", "chain S and hpCs-I_7W59")
        cmd.extract("SNRNP200_hpCs-I_7W59", "chain D and hpCs-I_7W59")
        cmd.extract("PPIE_hpCs-I_7W59", "chain y and hpCs-I_7W59")
        cmd.extract("SNRNP40_hpCs-I_7W59", "chain E and hpCs-I_7W59")
        cmd.extract("SNRPD3_hpCs-I_7W59", "(chain a or chain h ) and hpCs-I_7W59")
        cmd.extract("SNRPB_hpCs-I_7W59", "(chain b or chain i ) and hpCs-I_7W59")
        cmd.extract("EIF4A3_hpCs-I_7W59", "chain u and hpCs-I_7W59")
        cmd.extract("SNRPD1_hpCs-I_7W59", "(chain c or chain j ) and hpCs-I_7W59")
        cmd.extract("MAGOH_hpCs-I_7W59", "chain v and hpCs-I_7W59")
        cmd.extract("SNRPD2_hpCs-I_7W59", "(chain d or chain k ) and hpCs-I_7W59")
        cmd.extract("RBM8A_hpCs-I_7W59", "chain w and hpCs-I_7W59")
        cmd.extract("SNRPF_hpCs-I_7W59", "(chain f or chain m ) and hpCs-I_7W59")
        cmd.extract("CASC3_hpCs-I_7W59", "chain x and hpCs-I_7W59")
        cmd.extract("SNRPE_hpCs-I_7W59", "(chain e or chain l ) and hpCs-I_7W59")
        cmd.extract("SNRPG_hpCs-I_7W59", "(chain g or chain n ) and hpCs-I_7W59")
        cmd.extract("SNRPA1_hpCs-I_7W59", "chain o and hpCs-I_7W59")
        cmd.extract("SNRPB2_hpCs-I_7W59", "chain p and hpCs-I_7W59")
        cmd.extract("CRNKL1_hpCs-I_7W59", "chain J and hpCs-I_7W59")
        cmd.extract("CDC5L_hpCs-I_7W59", "chain L and hpCs-I_7W59")
        cmd.extract("PRPF19_hpCs-I_7W59", "(chain q or chain r or chain s or chain t ) and hpCs-I_7W59")
        cmd.extract("BCAS2_hpCs-I_7W59", "chain K and hpCs-I_7W59")
        cmd.extract("SKIP_hpCs-I_7W59", "chain R and hpCs-I_7W59")
        cmd.extract("SRRM2_hpCs-I_7W59", "chain U and hpCs-I_7W59")
        cmd.extract("CDC40_hpCs-I_7W59", "chain W and hpCs-I_7W59")
        cmd.extract("DHX8_hpCs-I_7W59", "chain Y and hpCs-I_7W59")
        cmd.extract("FAM32A_hpCs-I_7W59", "chain z and hpCs-I_7W59")
        cmd.extract("NKAP_hpCs-I_7W59", "chain 3 and hpCs-I_7W59")
        cmd.extract("Cactin_hpCs-I_7W59", "chain Z and hpCs-I_7W59")
        cmd.set_name("hpCs-I_7W59", "unknown_other_hpCs-I_7W59")
        cmd.group("hpCs-I_7W59", "*_hpCs-I_7W59")
        cmd.do("order *, yes")
    if 'hpCs_7W5B'.lower() in name.lower():
        cmd.extract("PRP8_hpCs_7W5B", "chain A and hpCs_7W5B")
        cmd.extract("BUD31_hpCs_7W5B", "chain N and hpCs_7W5B")
        cmd.extract("CWC15_hpCs_7W5B", "chain P and hpCs_7W5B")
        cmd.extract("CWC2_RBM22_hpCs_7W5B", "chain O and hpCs_7W5B")
        cmd.extract("CWC22_hpCs_7W5B", "chain V and hpCs_7W5B")
        cmd.extract("PRP46_hpCs_7W5B", "chain T and hpCs_7W5B")
        cmd.extract("SYF2_hpCs_7W5B", "chain M and hpCs_7W5B")
        cmd.extract("SYF1_hpCs_7W5B", "chain I and hpCs_7W5B")
        cmd.extract("U2_hpCs_7W5B", "chain H and hpCs_7W5B")
        cmd.extract("U5_hpCs_7W5B", "chain B and hpCs_7W5B")
        cmd.extract("U6_hpCs_7W5B", "chain F and hpCs_7W5B")
        cmd.extract("5EXON_hpCs_7W5B", "chain 4 and hpCs_7W5B")
        cmd.extract("Intron_hpCs_7W5B", "chain G and hpCs_7W5B")
        cmd.extract("SLU7_hpCs_7W5B", "chain 1 and hpCs_7W5B")
        cmd.extract("PRKRIP1_hpCs_7W5B", "chain 2 and hpCs_7W5B")
        cmd.extract("AQR_hpCs_7W5B", "chain Q and hpCs_7W5B")
        cmd.extract("SNRP116_hpCs_7W5B", "chain C and hpCs_7W5B")
        cmd.extract("PPIL1_hpCs_7W5B", "chain S and hpCs_7W5B")
        cmd.extract("SNRNP200_hpCs_7W5B", "chain D and hpCs_7W5B")
        cmd.extract("PPIE_hpCs_7W5B", "chain y and hpCs_7W5B")
        cmd.extract("SNRNP40_hpCs_7W5B", "chain E and hpCs_7W5B")
        cmd.extract("SNRPD3_hpCs_7W5B", "(chain a or chain h ) and hpCs_7W5B")
        cmd.extract("SNRPB_hpCs_7W5B", "(chain b or chain i ) and hpCs_7W5B")
        cmd.extract("EIF4A3_hpCs_7W5B", "chain u and hpCs_7W5B")
        cmd.extract("SNRPD1_hpCs_7W5B", "(chain c or chain j ) and hpCs_7W5B")
        cmd.extract("MAGOH_hpCs_7W5B", "chain v and hpCs_7W5B")
        cmd.extract("SNRPD2_hpCs_7W5B", "(chain d or chain k ) and hpCs_7W5B")
        cmd.extract("RBM8A_hpCs_7W5B", "chain w and hpCs_7W5B")
        cmd.extract("SNRPF_hpCs_7W5B", "(chain f or chain m ) and hpCs_7W5B")
        cmd.extract("CASC3_hpCs_7W5B", "chain x and hpCs_7W5B")
        cmd.extract("SNRPE_hpCs_7W5B", "(chain e or chain l ) and hpCs_7W5B")
        cmd.extract("SNRPG_hpCs_7W5B", "(chain g or chain n ) and hpCs_7W5B")
        cmd.extract("SNRPA1_hpCs_7W5B", "chain o and hpCs_7W5B")
        cmd.extract("SNRPB2_hpCs_7W5B", "chain p and hpCs_7W5B")
        cmd.extract("CRNKL1_hpCs_7W5B", "chain J and hpCs_7W5B")
        cmd.extract("CDC5L_hpCs_7W5B", "chain L and hpCs_7W5B")
        cmd.extract("PRPF19_hpCs_7W5B", "(chain q or chain r or chain s or chain t ) and hpCs_7W5B")
        cmd.extract("BCAS2_hpCs_7W5B", "chain K and hpCs_7W5B")
        cmd.extract("SKIP_hpCs_7W5B", "chain R and hpCs_7W5B")
        cmd.extract("SRRM2_hpCs_7W5B", "chain U and hpCs_7W5B")
        cmd.extract("CDC40_hpCs_7W5B", "chain W and hpCs_7W5B")
        cmd.extract("DHX8_hpCs_7W5B", "chain Y and hpCs_7W5B")
        cmd.extract("FAM32A_hpCs_7W5B", "chain z and hpCs_7W5B")
        cmd.extract("NKAP_hpCs_7W5B", "chain 3 and hpCs_7W5B")
        cmd.extract("Cactin_hpCs_7W5B", "chain Z and hpCs_7W5B")
        cmd.set_name("hpCs_7W5B", "unknown_other_hpCs_7W5B")
        cmd.group("hpCs_7W5B", "*_hpCs_7W5B")
        cmd.do("order *, yes")
